import * as Y from "yjs";

/** @typedef {import('svelte/store').Readable<string> & { y: Y.Text }} YReadableText */

/**
 * @param {Y.Text} ytext
 * @returns {YReadableText}
 */
export function readableText(ytext) {
  return {
    subscribe(run) {
      const cb = () => run(ytext.toString());
      cb();
      ytext.observe(cb);
      return () => {
        ytext.unobserve(cb);
      };
    },
    y: ytext,
  };
}
