import { derived, writable } from "svelte/store";
import { getUserY, type UserIdentifier } from "../../doc";

type Type = UserIdentifier[];

const start: Type = JSON.parse(localStorage.friends || "[]");
const save = (v: Type) => (localStorage.friends = JSON.stringify(v));

const store = writable(start);
store.subscribe(save);
export default store;

export const friendsData = derived(store, ($friends) =>
  $friends.map((id) => ({ id, userY: getUserY(id) }))
);
